"use strict";
// Operations
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GrayTheme = exports.DarkTheme = exports.LightTheme = void 0;
const color_1 = __importDefault(require("color"));
function gray(svg, size) {
    const fill = color_1.default("white").lightness(60);
    svg.width(size);
    svg.height(size);
    svg.last().fill(fill.hex());
    svg
        .path("M 0, 100 C 0, 35 35, 0 100, 0 S 200, 35 200, 100 165, 200 100, 200 0, 165 0, 100")
        .attr("transform", `scale(${svg.viewbox().w / 200})`)
        .back()
        .fill(color_1.default("white").hex());
}
function dark(svg, size) {
    let fill = color_1.default(svg.first().attr("fill"));
    if (fill.lightness() > 50)
        fill = fill.lightness(50);
    svg.width(size);
    svg.height(size);
    svg.last().fill("white");
    svg
        .path("M 0, 100 C 0, 35 35, 0 100, 0 S 200, 35 200, 100 165, 200 100, 200 0, 165 0, 100")
        .attr("transform", `scale(${svg.viewbox().w / 200})`)
        .back()
        .fill(fill.hex());
}
function light(svg, size) {
    let fill = color_1.default(svg.first().attr("fill"));
    if (fill.lightness() > 50)
        fill = fill.lightness(50);
    svg.width(size);
    svg.height(size);
    svg.last().fill(fill.hex());
    svg
        .path("M 0, 100 C 0, 35 35, 0 100, 0 S 200, 35 200, 100 165, 200 100, 200 0, 165 0, 100")
        .attr("transform", `scale(0.16)`)
        .back()
        .fill(fill.rgb().alpha(0.2).string());
}
class LightTheme {
    constructor(size) {
        this.size = size;
    }
    visit(instance) {
        instance.modifySVG((coin) => light(coin, this.size));
    }
}
exports.LightTheme = LightTheme;
class DarkTheme {
    constructor(size) {
        this.size = size;
    }
    visit(instance) {
        instance.modifySVG((coin) => dark(coin, this.size));
    }
}
exports.DarkTheme = DarkTheme;
class GrayTheme {
    constructor(size) {
        this.size = size;
    }
    visit(instance) {
        instance.modifySVG((coin) => gray(coin, this.size));
    }
}
exports.GrayTheme = GrayTheme;
